#
# Conditional build:
%bcond_without	doc	# Sphinx documentation
%bcond_without	tests	# unit tests

%define	module	FormEncode
Summary:	HTML form validation, generation, and convertion package
Summary(pl.UTF-8):	Moduł do walidacji, tworzenia i konwersji formularzy HTML
Name:		python3-%{module}
# keep 2.0.x here for python2 support
Version:	2.1.1
Release:	1
License:	PSF
Group:		Development/Languages/Python
#Source0Download: https://pypi.org/project/FormEncode/
Source0:	https://files.pythonhosted.org/packages/source/f/formencode/formencode-%{version}.tar.gz
# Source0-md5:	d179386d31ae8c32e70d004dca19ac60
Patch0:		no-egg-dep.patch
URL:		http://formencode.org/
BuildRequires:	python3-modules >= 1:3.6
BuildRequires:	python3-setuptools
BuildRequires:	python3-setuptools_scm
%if %{with tests}
BuildRequires:	pydoc3 >= 1:3.6
BuildRequires:	python3-dns >= 2.0.0
BuildRequires:	python3-pycountry >= 16.10.23
BuildRequires:	python3-pytest
BuildRequires:	python3-six
%endif
BuildRequires:	rpm-pythonprov
BuildRequires:	rpmbuild(macros) >= 1.714
BuildRequires:	sed >= 4.0
%{?with_doc:BuildRequires:	sphinx-pdg}
Requires:	python3-modules >= 1:3.6
BuildArch:	noarch
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%description
FormEncode validates and converts nested structures. It allows for a
declarative form of defining the validation, and decoupled processes
for filling and generating forms.

%description -l pl.UTF-8
FormEncode służy do sprawdzania poprawności i konwersji zagnieżdżonych
struktur. Pozwala na deklaratywny sposób definiowania reguł
poprawności i niezależne od nich wypełnianie i generowanie formularzy.

%package apidocs
Summary:	API documentation for Python FormEncode module
Summary(pl.UTF-8):	Dokumentacja API modułu Pythona FormEncode
Group:		Documentation

%description apidocs
API documentation for Python FormEncode module.

%description apidocs -l pl.UTF-8
Dokumentacja API modułu Pythona FormEncode.

%prep
%setup -q -n formencode-%{version}
%patch -P0 -p1

# uses network to validate domains (with one no longer valid anyway)
%{__rm} tests/test_email.py
# validator doctests cover Email and URL validators which include DNS lookups
%{__sed} -i -e '/^modules / s/, validators//' tests/test_doctests.py

%{__sed} -i -e 's/@VERSION@/%{version}/' docs/conf.py

%build
%py3_build

%if %{with tests}
PYTEST_DISABLE_PLUGIN_AUTOLOAD=1 \
PYTHONPATH="$(pwd)/build-3/lib" \
%{__python3} -m pytest tests
%endif

%{?with_doc:PYTHONPATH="$(pwd)/build-3/lib" ./regen-docs}

%install
rm -rf $RPM_BUILD_ROOT

%py3_install

find $RPM_BUILD_ROOT%{py3_sitescriptdir}/formencode/i18n -type d -maxdepth 1 | \
	%{__sed} -ne "s,$RPM_BUILD_ROOT\(.*i18n/\([a-z]\+\(_[A-Z][A-Z]\)\?\).*\),%%lang(\2) \1,p" > py3.lang

%clean
rm -rf $RPM_BUILD_ROOT

%files -f py3.lang
%defattr(644,root,root,755)
%doc README.rst
%dir %{py3_sitescriptdir}/formencode
%{py3_sitescriptdir}/formencode/*.py
%{py3_sitescriptdir}/formencode/__pycache__
%dir %{py3_sitescriptdir}/formencode/i18n
%{py3_sitescriptdir}/formencode/javascript
%{py3_sitescriptdir}/FormEncode-%{version}-py*.egg-info

%if %{with doc}
%files apidocs
%defattr(644,root,root,755)
%doc docs/_build/*
%endif
%changelog
* Sun Mar 16 2025 PLD Linux Team <feedback@pld-linux.org>
- For complete changelog see: http://git.pld-linux.org/?p=packages/python3-FormEncode.git;a=log;h=master

* Sun Mar 16 2025 Jan Palus <atler@pld-linux.org> baeb2c7
- up to 2.1.1

* Tue Mar 11 2025 Jan Rękorajski <baggins@pld-linux.org> 9d292c8
- doc/test rebuild for python 3.13

* Mon Mar 10 2025 Jan Rękorajski <baggins@pld-linux.org> 8aa9e68
- python 3.13 rebuild

* Tue Sep 19 2023 Jakub Bogusz <qboosh@pld-linux.org> dd6100d
- release 2

* Tue Sep 19 2023 Jakub Bogusz <qboosh@pld-linux.org> 8cc4305
- disable pytest plugin autoload

* Mon Sep 18 2023 Jakub Bogusz <qboosh@pld-linux.org> f0cb4fc
- updated to 2.0.1; now uses six instead of no longer supported 2to3 setuptools option

* Fri Apr 08 2022 Jan Rękorajski <baggins@pld-linux.org> 0b38746
- remove bogus version detection, rel 5

* Sat Mar 26 2022 Jan Rękorajski <baggins@pld-linux.org> ba7e674
- rebuild with python 3.10

* Fri Mar 25 2022 Jan Rękorajski <baggins@pld-linux.org> dc50037
- rebuild with python 3.10

* Sat Feb 27 2021 Jan Rękorajski <baggins@pld-linux.org> 3cf2490
- release 2 (by relup.sh)

* Tue Jun 09 2020 Jakub Bogusz <qboosh@pld-linux.org> edc83fe
- disable also validator doctests due to DNS lookups

* Tue Jun 09 2020 Jakub Bogusz <qboosh@pld-linux.org> d7c2098
- updated to 1.3.1
- added pycountry patch (adapt for pycountry 16.10.23 API change)
- added python3- and -apidocs packages

* Sun Nov 29 2015 Jacek Konieczny <jajcus@jajcus.net> 5b5e451
- BR: rpmbuild(macros) >= 1.710

* Sat Nov 28 2015 Jacek Konieczny <jajcus@jajcus.net> dbb6612
- release 2 (by relup.sh)

* Sat Nov 28 2015 Jacek Konieczny <jajcus@jajcus.net> 3413432
- automatic change: use py_build/py_install macros

* Thu Jan 12 2012 zbyniu <zbyniu@pld-linux.org> 9ba635c
- up to 1.2.4

* Sat Nov 13 2010 pawelz <pawelz@pld-linux.org> 1d33453
- release 3

* Thu Jul 08 2010 Arkadiusz Miśkiewicz <arekm@maven.pl> 0238e9f
- release 2

* Sun Mar 15 2009 duddits <duddits@pld-linux.org> 632f4e5
- up to 1.2.2

* Sun Oct 19 2008 Arkadiusz Miśkiewicz <arekm@maven.pl> de2a59a
- up to 1.0.1

